/**                  Name: Yinyi Guo
 *  Section Leader's Name: Ben Phillips
 *
 *  This application is a Random Writer
 *
 */
#include <iostream>
#include <string> 
#include <fstream>
#include "genlib.h"
#include "simpio.h"
#include "strutils.h"
#include <map.h>
#include "vector.h"
#include <cstdlib>
#include <random.h>

/*
 *This function is to Build up a map to represent the Markov Model 
 *    with Strings and following letters, reading from an original text
 */
void BuildMap(int& order, ifstream& infile, Map< Vector<char> >& map) 
{
	do {
		string line ="" ;
		for (int i = 0; i< order ; i++)
		{
			line +=infile.peek();
			infile.get();
	    }
		char f= infile.peek();  // the letter follows the string (value)			
		map[line].add(f);
		map.add(line, map[line]);
		for (int i = 0; i< order ; i++)
		{
			infile.unget();
		}
	}
	while (infile.get()!=-1);  // get() once... 
}

/*
 * This function is to get the the key of the longest value in the map, for initialize output text
 */
string getTheMax(Map<Vector<char> >& map)
{
	Map<Vector<char> >::Iterator iter = map.iterator();
	string maxkey;
	int maxsize =0;
	while (iter.hasNext()) {
		string key = iter.next();
		for (int i=0; i< map[key].size();i++) {
		}
		if (map[key].size() > maxsize) {
			maxsize = map[key].size();
			maxkey = key;
		}
	}
	return maxkey;
}

/*
 * This function is to generate text randomly according to the Markov Model 
 */
void RandomGenerate(Map<Vector<char> >& map, string& seed)
{
	cout<< seed;
	int index;
	char follow;
	char space = ' ';
	int n = seed.size();
	while (n < 2001) {     // we need 2000 characters
		index = RandomInteger(0, map[seed].size()-1);  // get index from certain possibilities 
		if (map[seed].size()< 1)       // unluckily reach the end of the text...
			follow = space;            // in case of unexpected termination
		else follow = map[seed][index];
		seed = seed.substr(1) + follow;  // update seed
		cout << follow;
		n++;
	}
}

/*
 *  Entry point 
 */
int main()
{
	Map< Vector<char> > map;
	ifstream infile0;
	string name;
	int order;
	while (true) {
		cout << "Please enter filename containing source text:";
		name = GetLine();
		infile0.open(name.c_str()); // return receiver string in old-style C-string form
		if (infile0.is_open()) {
			while (true) {
				cout << "What order of analysis? (a number from 1 to 10): ";
				order = GetInteger();
				if (order <11 && order >0) {  // order should be from 1 to 10
					break;
				}
				cout << "Try again "<< endl;
			}
			break;
		}
		else 
			cout << "Could not open file named "<< name.c_str() << ". Please try again."<< endl;
	}
	ifstream infile(name.c_str());
	BuildMap(order, infile, map);      // have map built
	string maxstring = getTheMax(map); // get the string with max value
	RandomGenerate(map, maxstring);    // random generate!
	return 0;
}

